// Copyright (C) 2013 by FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of demoHeterogeneousParallelism.
// 
// demoHeterogeneousParallelism is free software: you can redistribute it and/or modify it under the terms of the GNU 
// General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your 
// option) any later version.
// 
// demoHeterogeneousParallelism is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
// even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
// for more details.
// 
// You should have received a copy of the GNU General Public License along with demoHeterogeneousParallelism. If not, 
// see <http://www.gnu.org/licenses/>.


// place-holder for your code: difference of gaussians sample application
// ======================================================================

#pragma once

#include "hawaii/GPU/openCV.h"

// gaussian blur: Results are cropped by window size minus one to avoid border extrapolation. Window covers five sigma.
void gaussCPU( const cv::Mat          orig,
                     cv::Mat&         blur,
               const cv::Size         win    = cv::Size( 11, 11 ) ) ;
void gaussGPU( const cv::gpu::GpuMat  orig,
                     cv::gpu::GpuMat& blur,
               const cv::Size         win    = cv::Size( 11, 11 ),
                     cv::gpu::Stream& stream = cv::gpu::Stream::Null() ) ;

// difference between images: auto-select center ROI if "orig" is bigger than "blur" due to cropping, map result range 
//                            from [-255,255] to [0,255]
void diffCPU( const cv::Mat          orig,
              const cv::Mat          blur,
                    cv::Mat&         diff ) ;
void diffGPU( const cv::gpu::GpuMat  orig,
              const cv::gpu::GpuMat  blur,
                    cv::gpu::GpuMat& diff,
                    cv::gpu::Stream& stream = cv::gpu::Stream::Null() ) ;
