// Copyright (C) 2013 by FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of libHawaii.
// 
// libHawaii is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
// License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
// version.
// 
// libHawaii is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with libHawaii. If not, see 
// <http://www.gnu.org/licenses/>.


// processing step to display images on the screen
// ===============================================

#pragma once

#include "hawaii/flow/step.h"
#include "hawaii/flow/itemNamedImages.h"

namespace hawaii {
namespace IO {

// processing step to display images on the screen
class StepDisplay : public hawaii::flow::StepTemplate< hawaii::flow::ItemNamedImages,
                                                       hawaii::flow::ItemBase        > {
	// c'tor with the option below
	public:
	StepDisplay( const int delayArg = 1 ) :
		hawaii::flow::StepTemplate< hawaii::flow::ItemNamedImages,
		                            hawaii::flow::ItemBase        >( "display images on screen",
		                                                             1, std::vector< int >(),
		                                                             false, true ),
		delay( delayArg ) {
	}
	
	// milliseconds to wait for a keystroke after rendering all images
	// user note: Non-positive values will wait infinitely.
	public:
	const int delay ;
	
	// implement inherited purely-virtual method to show all images within the item
	public:
	virtual void processImpl( const SrcPtr& srcPtr,
	                                DstPtr& dstPtr ) override ;
} ;

} } // namespaces "hawaii::IO"
