// Copyright (C) 2013 by FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of libHawaii.
// 
// libHawaii is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
// License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
// version.
// 
// libHawaii is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with libHawaii. If not, see 
// <http://www.gnu.org/licenses/>.


// shorter names for common primitive data types
// =============================================

#pragma once

#include <stdint.h>

// abbreviated integer names without number of bits (You may prefer using "(u)int{8,16,32,64}_t".)
typedef unsigned char      uchar     ;
typedef unsigned short     ushort    ;
typedef unsigned int       uint      ;
typedef unsigned long      ulong     ;
typedef unsigned long long ulonglong ;
typedef          long long  longlong ;

// more readable color pixel access than with OpenCV's "cv::Vec{3,4}b" or CUDA's "uchar{3,4}"
struct BGR  { uint8_t b, g, r    ; BGR()  : b( 0 ), g( 0 ), r( 0 )           {} ; BGR(  uint8_t bArg, uint8_t gArg, uint8_t rArg                     ) : b( bArg ), g( gArg ), r( rArg )            {} } ;
struct BGRA { uint8_t b, g, r, a ; BGRA() : b( 0 ), g( 0 ), r( 0 ), a( 255 ) {} ; BGRA( uint8_t bArg, uint8_t gArg, uint8_t rArg, uint8_t aArg = 255 ) : b( bArg ), g( gArg ), r( rArg ), a( aArg ) {} } ;
