// Copyright (C) 2013 by FZI Forschungszentrum Informatik am Karlsruher Institut fuer Technologie
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of libHawaii.
// 
// libHawaii is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
// License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
// version.
// 
// libHawaii is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with libHawaii. If not, see 
// <http://www.gnu.org/licenses/>.


// processing step to display images on the screen
// ===============================================

#include "hawaii/IO/display.h"
#include <opencv2/highgui/highgui.hpp>

namespace hawaii {
namespace IO {

// implement inherited purely-virtual method to show all images within the item
void StepDisplay::processImpl( const SrcPtr& srcPtr,
                                     DstPtr& dstPtr ) {
	
	// generate an output item for performance measurement even though this is a sink
	dstPtr = DstPtr( new Dst( srcPtr->serialNumber ) ) ;
	
	// show all the images
	for( const auto& image : srcPtr->images ) {
		cv::imshow( image.first, image.second ) ;
	}
	cv::waitKey( this->delay ) ;
}

} } // namespaces "hawaii::IO"
